//$Id: time.h,v 2.6 1999/04/13 20:43:23 pinon Exp $
#ifndef time_h
#define time_h


#include "subtime.h"
#include <stdio.h>

//#define USE_LONG_DOUBLE

class Time : public JD
{
  
private:

  static  GPST gps_launch_t;
  static  UTC  utc_launch_t;
  
public:
  
  Time() {};

  Time(UTC launch_t) { set(launch_t); };                            

  Time(int year, int month,
       int day,  int hour,
#ifdef USE_LONG_DOUBLE
       int min,  long double sec)
#else
       int min,  double sec)
#endif
    {
      set(year,month,day,hour,min,sec);
    };


  //
  // Set the time based on UTC or Y/M/D H:M:S
  //
  void set(UTC launch_t);                            
  
  void set(int year, int month,
	   int day,  int hour,
#ifdef USE_LONG_DOUBLE
	   int min,  long double sec);
#else
	   int min,  double sec);
#endif

  
  //
  // Get the time based on UTC or Y/M/D H:M:S
  //
  void get(UTC *launch_t);
  
  void get(int *year, int *month,
	   int *day,  int *hour,
#ifdef USE_LONG_DOUBLE
	   int *min,  long double *sec);
#else
	   int *min,  double *sec);
#endif
    

  //
  // Print the xxx_launch values
  //
  void print(void);
  

  //
  // Convert all subtime classes to GPST
  //
  void convert(const UTC *utc,       GPST *gps);   
  void convert(const MET *met,       GPST *gps);   
  void convert(const STST *st,       GPST *gps);   
  void convert(const GPSclock *gpsc, GPST *gps);
                                 

  //
  // Convert all subtime classes to UTC
  //                       
  void convert(const GPST *gps,      UTC *utc);
  void convert(const MET *met,       UTC *utc);
  void convert(const STST *st,       UTC *utc);
  void convert(const GPSclock *gpsc, UTC *utc);

                                                        
  //
  // Convert all subtime classes to MET
  //
  void convert(const GPST *gps,      MET *met);
  void convert(const UTC *utc,       MET *met);
  void convert(const STST *st,       MET *met);
  void convert(const GPSclock *gpsc, MET *met);
                                                        

  //
  // Convert all subtime classes to STST
  //
  void convert(const GPST *gps,      STST *st);
  void convert(const UTC *utc,       STST *st);
  void convert(const MET *met,       STST *st);
  void convert(const GPSclock *gpsc, STST *st);
                                                        

  //
  // Convert all subtime classes to GPSclock
  //
  void convert(const GPST *gps,      GPSclock *gpsc);
  void convert(const UTC *gps,       GPSclock *gpsc);
  void convert(const MET *gps,       GPSclock *gpsc);
  void convert(const STST *gps,      GPSclock *gpsc);

};
#endif
